﻿Type=Class
Version=5.8
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
#Event: ItemClick (Place As PlaceData)
#DesignerProperty: Key: HighlightColor, DisplayName: Highlight Color, FieldType: Color, DefaultValue: 0xFFFC1010
#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFF000000
'Class module
Sub Class_Globals
	Private prefixList As Map
	Private substringList As Map
	Private et As TextField
	Private lv As ListView
	Private MIN_LIMIT = 1, MAX_LIMIT = 4 As Int 'doesn't limit the words length. Only the index.
	Private mCallback As Object
	Private mEventName As String
	Private mBase As Pane
	Private highlightColor, textColor As Paint
	Private ROWHEIGHT As Int = 25
	Private tf As TextFlow
	Private QueryIndexSent, QueryIndexReceived As Int
	Type PlaceData (Description As String, Id As String)
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	mEventName = vEventName
	mCallback = vCallback
	prefixList.Initialize
	substringList.Initialize
	tf.Initialize
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	highlightColor = Props.Get("HighlightColor")
	textColor = Props.Get("TextColor")
	Sleep(0) 'it is not possible to load a layout while another one is loaded. By using Sleep we wait for the first layout to be loaded.
	mBase.LoadLayout("SearchView")
	lv.Visible = False
	Dim r As Reflector
	r.Target = et
	r.AddEventFilter("et", "javafx.scene.input.KeyEvent.KEY_PRESSED")
	r.Target = lv
	r.AddEventFilter("lv", "javafx.scene.input.KeyEvent.KEY_PRESSED")
End Sub



Sub et_Filter (EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	If code = "DOWN" And lv.Visible = True And lv.Items.Size > 0 Then
		lv.RequestFocus
		lv.SelectedIndex = 0
		EventData.Consume
	End If
End Sub

Sub lv_Filter (EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	If code = "UP" And lv.SelectedIndex <= 0 Then
		et.RequestFocus
		EventData.Consume
	Else if code = "ENTER" Then
		SelectItem
		EventData.Consume
	End If
End Sub


Public Sub GetBase As Pane
	Return mBase
End Sub

Sub lv_MouseClicked (EventData As MouseEvent)
	SelectItem
End Sub

Sub SelectItem
	Sleep(0) 'let the selected item be updated if needed
	If lv.SelectedIndex > -1 Then
		Dim p As Pane = lv.SelectedItem
		Dim pd As PlaceData = p.Tag
		et.Text = pd.Description
		Sleep(0) 'pass et_TextChanged event
		et.SetSelection(et.Text.Length, et.Text.Length)
		lv.Visible = False
		If SubExists(mCallback, mEventName & "_ItemClick") Then
			CallSub2(mCallback, mEventName & "_ItemClick", pd)
		End If
	End If
End Sub


Private Sub et_TextChanged (Old As String, New As String)
	If New.Length = 0 Then
		lv.Visible = False
		Return
	Else
		If lv.Visible = False Then lv.Visible = True
		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download2("https://maps.googleapis.com/maps/api/place/autocomplete/json", _
			Array As String("input", New, "key", Main.GoogleApiKey))
		QueryIndexSent = QueryIndexSent + 1
		Dim index As Int = QueryIndexSent
		Wait For (j) JobDone (j As HttpJob)
		If j.Success Then
			If QueryIndexReceived > index Then
				Return
			Else
				Dim pds As List
				pds.Initialize
				lv.Items.Clear
				QueryIndexReceived = index
				Dim jp As JSONParser
				jp.Initialize(j.GetString)
				Dim m As Map = jp.NextObject
				Dim predictions As List = m.Get("predictions")
				For Each pred As Map In predictions
					Dim pd As PlaceData
					pd.Initialize
					pd.Id = pred.Get("place_id")
					pd.Description = pred.Get("description")
					pds.Add(pd)
				Next
				AddItemsToList(pds, New.ToLowerCase)
				lv.PrefHeight = Min(mBase.PrefHeight - et.PrefHeight, Max(5, lv.Items.Size) * (ROWHEIGHT + 9))
			End If
		End If
		j.Release
	End If
End Sub

Private Sub AddItemsToList(li As List, full As String)
	If li.IsInitialized = False Then Return
	For Each Item As PlaceData In li
		Dim desc As String = Item.Description
		Dim x As Int = desc.ToLowerCase.IndexOf(full)
		If x = -1 Then
			Continue
		End If
		tf.Reset.AddText(desc.SubString2(0, x)).SetColor(textColor).AddText(desc.SubString2(x, x + full.Length)).SetColor(highlightColor)
		tf.AddText(desc.SubString(x + full.Length)).SetColor(textColor)
		Dim p As Pane = tf.CreateTextFlow
		p.Tag = Item
		p.PrefHeight = ROWHEIGHT
		lv.Items.Add(p)
	Next
End Sub






